#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern const byte[] Chars, Logo;

byte[256] CharColors;

static const byte[] ColorSource = {
	Char_Fence, 2, Color_Blue,
	Char_Line_Red, 8, Color_Red,
	Char_Increaser, 4, Color_Green,
	Char_Block, 4, Color_Cyan,
	Char_Item, 4, Color_Yellow,
	Char_Man, 4, Color_White,
	Char_Monster, 16, Color_Magenta,
    Char_Remain, 4, Color_White,
    0xff
};

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}


void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = Color_White;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
    CopyPattern(Char_Ascii, Pattern_Ascii, Pattern_Man - Pattern_Ascii);
    CopyPattern(Char_Logo + 0x80, Pattern_Logo, 16);
    CopyPattern(Char_Remain, Pattern_Man_Left, 4);
}


void ClearScreen()
{
    FillMemory(VramBase, VramRowSize * (VramHeight + MarginHeight), Color_White);
}


void Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            *pVram = c; ++pVram;
            ++c;
        }
        pVram += VramRowSize - 2;
    }
}
